Package io.vertx.ext.auth.oauth2.providers

## Interface AmazonCognitoAuth

- All Superinterfaces:
    `OpenIDConnectAuth`

      public interface AmazonCognitoAuth
      extends OpenIDConnectAuth

  Simplified factory to create an `OAuth2Auth` for Amazon Cognito.
  Author:
    Paulo Lopes

- - ### Method Summary

    Static Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static OAuth2Auth` | `create​(Vertx vertx, String region, String clientId, String clientSecret, String domain, String guid)` | Create a OAuth2Auth provider for Amazon Cognito
    `static OAuth2Auth` | `create​(Vertx vertx, String region, String clientId, String clientSecret, String domain, String userPoolId, HttpClientOptions httpClientOptions)` | Create a OAuth2Auth provider for Amazon Cognito
    `static Future<OAuth2Auth>` | `discover​(Vertx vertx, OAuth2Options config)` | Create a OAuth2Auth provider for OpenID Connect Discovery.

- - ### Method Detail

    - #### create

          static OAuth2Auth create​(Vertx vertx,
                                   String region,
                                   String clientId,
                                   String clientSecret,
                                   String domain,
                                   String guid)

      Create a OAuth2Auth provider for Amazon Cognito
      Parameters:
        `region` - the region to use
        `clientId` - the client id given to you by Amazon Cognito
        `clientSecret` - the client secret given to you by Amazon Cognito
        `domain` - the Cognito domain
        `guid` - the guid of your application given to you by Amazon Cognito

    - #### create

          static OAuth2Auth create​(Vertx vertx,
                                   String region,
                                   String clientId,
                                   String clientSecret,
                                   String domain,
                                   String userPoolId,
                                   HttpClientOptions httpClientOptions)

      Create a OAuth2Auth provider for Amazon Cognito
      Parameters:
        `region` - the region to use
        `clientId` - the client id given to you by Amazon Cognito
        `clientSecret` - the client secret given to you by Amazon Cognito
        `domain` - the Cognito domain
        `userPoolId` - the userPoolId of your application given to you by Amazon Cognito
        `httpClientOptions` - custom http client options

    - #### discover

          static Future<OAuth2Auth> discover​(Vertx vertx,
                                             OAuth2Options config)

      Create a OAuth2Auth provider for OpenID Connect Discovery. The discovery will use the default site in the configuration options and attempt to load the well known descriptor. If a site is provided (for example when running on a custom instance) that site will be used to do the lookup.

      If the discovered config includes a json web key url, it will be also fetched and the JWKs will be loaded into the OAuth provider so tokens can be decoded.

      Parameters:
        `vertx` - the vertx instance
        `config` - the initial config
      Returns:
        future with instantiated Oauth2 provider instance handler
      See Also:
        `AmazonCognitoAuth#discover(Vertx, OAuth2Options, Handler)`